#!/usr/bin/perl

my $jpath = "";
my @words = @ARGV;
local $jrtempfile = "jdread.lst";

my @files = read_dir($jpath);
my $num = 0;
open(OUT,">$jrtempfile");
foreach $afile (sort @files) {
	print "	check $afile ...\n";
	if(@words) {
		my $flag = 0;
		foreach $aword (@words) {
			if($afile =~ /$aword/i) { $flag = 1;}
		}
		if($flag) {
			print OUT sprintf("J%03d|%s|\n",$num,$afile);
		}
	}
	else {
			print OUT sprintf("J%03d|%s|\n",$num,$afile);
	}
	$num++;
}
close(OUT);
print "	copy $jrtempfile jdwrite.lst\n";
system("copy $jrtempfile jdwrite.lst");
system("gvim jdwrite.lst");

sub read_dir {
	my ($jpath) = @_;
	my @lists = ();

	print("dir $jpath > $jrtempfile\n");
	system("dir $jpath > $jrtempfile");
	open(IN,"$jrtempfile");
	my @files =<IN>;
	close(IN);
	system("del $jrtempfile");

	foreach $afile (@files) {
		my ($fname,$fext,$fsize,$fdate,$ftime,$flname)
			= &read_dirline($afile);
		print "O:$fname:$fext:$fsize:$fdate:$ftime:$flname:\n";
		if(! $fname) {
			#rint " ...Nothing...\n";
		}
		elsif($fname =~ /^\./) {
			#rint ".:$fname:$fext:$fsize:$fdate:$ftime:$flname:\n";
		}
		elsif($fsize =~ /\<DIR\>/) {
			#rint "D:$fname:$fext:$fsize:$fdate:$ftime:$flname:$jpath:\n";
		}
		else {
			#rint "F:$fname:$fext:$fsize:$fdate:$ftime:$flname:$jpath:\n";
			push(@lists,$flname);
		}
	}
	return @lists;
}

sub read_dirline {
	my ($dirline) = @_;
	chop($dirline);
	print "dirline:$dirline\n";

	if($afile =~ /^\s/) {
		return ();
	}
	else {
		my @abc = split('',$dirline,13);
		my $fname = join('',@abc[0..7]);
		$fname =~ s/\s//g;
		my $fext = join('',@abc[9..11]);
		$fext =~ s/\s//g;
		$abc[12] =~ s/^[\s]+//g;
		my ($fsize,$fdate,$ftime,$flname) = split(/[\s]+/,$abc[12],4);
		return($fname,$fext,$fsize,$fdate,$ftime,$flname);
	}
}
